<%@page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@page import="java.io.IOException"%>
<%@page import="java.io.File"%>
<%@page import="java.util.Map"%>
<%@page import="java.util.Collection"%>
<%@page import="javax.script.ScriptEngineManager"%>
<%@page import="javax.script.ScriptEngine"%>
<%@page import="javax.script.ScriptException"%>
<%@page import="com.google.common.base.Charsets"%>
<%@page import="com.google.common.io.Files"%>
<%
boolean debug = (request.getParameter("debug") != null);
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
  <head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>QTI Composer v2</title>
    <link rel="stylesheet" type="text/css" href="//code.jquery.com/ui/1.11.2/themes/smoothness/jquery-ui.css">
<% if (debug) {
		Collection<String> cssFiles = extractFileListFromGruntfile(request, "concat.qtiComposer_css.src");
		for (String cssFile : cssFiles) {
%>
	<link rel="stylesheet" type="text/css" href="<%=cssFile%>" />
<% 		} %>
    <script type="text/javascript" src="//code.jquery.com/jquery-1.11.0.js"></script>
    <script type="text/javascript" src="//code.jquery.com/ui/1.11.2/jquery-ui.js"></script>
<% } else { %>
    <link rel="stylesheet" type="text/css" href="dist/qtiComposer.css">
    <script type="text/javascript" src="//code.jquery.com/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="//code.jquery.com/ui/1.11.2/jquery-ui.min.js"></script>
<% } %>
    <script type="text/javascript" src="js/require.js"></script>
    <script>
		require.config({
			waitSeconds: 200,
			paths: {
				//'jsxgraphcoreLib': 'js/localjsxgraph/jsxgraphcore.99.6'
				'jsxgraphcore': 'js/localjsxgraph/jsxgraphcore'
			}
		});
<% if (!debug) { %>
		require.config({
			bundles: { 'dist/qtiComposer.min': [ 'js/common', 'js/examples', 'js/composer', 'js/composer2', 'js/qtiController', 'js/rubricFinder' ] }
		});
<% } %>
		requirejs.onError = function (err) {
		    console.log(err.requireType);
		    if (err.requireType === 'timeout') {
		        console.log('modules: ' + err.requireModules);
		    }
		
		    throw err;
		};
		define("jquery", function() { return jQuery; });
		define("jquery-ui", function() { return jQuery.ui; });
		require(['js/composer2-test', 'jsxgraphcore', 'js/graphingInteraction-common']);
	</script>
    <style>
        body {
            font-family: helvetica,arial,sans-serif;
            font-size: 14px;
        }
		#demo {
			margin: 8px;
			left: 0;
			top: 0;
			bottom: 0;
			width: 1000px;
			position: absolute;
		}
    </style>
  </head>
<body>
	<div id="demo"></div>
</body>
</html>

<%!
	private static Collection<String> extractFileListFromGruntfile(HttpServletRequest request, String path) throws ScriptException, IOException {
		String ourPath = request.getServletContext().getRealPath(request.getServletPath());
		File gruntfile = new File(new File(ourPath).getParent(), "Gruntfile.js");
 		String gruntfileJs = Files.asCharSource(gruntfile, Charsets.UTF_8).read();
		ScriptEngine engine = new ScriptEngineManager().getEngineByName("JavaScript");
		String extractScript = "(function () {module={};noop=function(){};\n" + gruntfileJs + "\n;module.exports({file: { readJSON: noop }, loadNpmTasks: noop, registerTask: noop, initConfig: function (config) {result=config;}});return result." + path +";})();";
		@SuppressWarnings("unchecked")
		Map<?, String> resultMap = (Map<?, String>) engine.eval(extractScript);
		return resultMap.values();
	}
%>

<%-- Local Variables: --%>
<%-- tab-width: 4 --%>
<%-- End: --%>
